function loo(xin,yin,C,str, RLPS, SMALLVALUE)
%sigmain, sigMethod, sigmaNegin,SMALLVALUE)
% Leave One Out  testing.
%  xin is the matrix of data, usually reduced down to
% just the non-zero genes found by a prior lpc run.
% yin is the vector of data labels,
fstr=strcat(str,'/loo.dat');
fout = fopen(fstr,'a');
%fout = fopen('loo.dat','a');
falspve =0;
falsnve =0;
[m,n]= size(xin);
fprintf('LOO %d %d\n',m,n);
if (n > 1)
  for exin = 1 : m
    x = xin;
    y = yin;
    x(exin,:) = [];
    y(exin) = [];

%    if (norm(sigma) == 0)
    if (RLPS.method == 0)
      [a, b] = lpc(x,y,C);
    else
%      RLPSforLOO = RLPS;
      RLPSforLOO.sigma = RLPS.sigma;
      RLPSforLOO.sigmaNeg = RLPS.sigmaNeg;
      RLPSforLOO.sigma(exin)=[];
      RLPSforLOO.sigmaNeg(exin) = [];
      RLPSforLOO.sigMethod = RLPS.sigMethod;
      RLPSforLOO.method = RLPS.method;
      RLPSforLOO.delta = RLPS.delta;
      [a, b] = rlpc(x,y,C, RLPSforLOO);
    end
    [a, zeroedNum] = threshold(a, SMALLVALUE);

    errtr(exin)=lpcerror(x,y,a,b);
    xtst = xin(exin,:);
    ytst = yin(exin);

    errtst(exin)=lpcerror(xtst,ytst,a,b);
    if and((ytst ==1), (errtst(exin)==1)) 
       falspve= falspve+1;
    end
    if and((ytst ==-1), (errtst(exin)==1)) 
       falsnve= falsnve+1;
    end
  end
else
  %only 1 example, don't try loo.
  errtr = 0;
  errtst = 0;
end;
fprintf('DONE LOO\n');
fprintf(fout, '%g %g %g %g %g %g %g \n', norm(RLPS.sigma,1)/m ,n, 0, sum(errtr)/m, sum(errtst), falspve,falsnve);
fclose(fout);



